﻿package {
	import org.jivesoftware.xiff.core.JID;
	import org.jivesoftware.xiff.core.XMPPSocketConnection;
	import com.hurlant.crypto.tls.TLSSocket;
	import com.hurlant.crypto.tls.TLSEvent;
	import flash.events.ProgressEvent;
	import flash.xml.XMLNode;
	import org.jivesoftware.xiff.data.Message;
	import org.jivesoftware.xiff.events.MessageEvent;
	import org.jivesoftware.xiff.exception.SerializationException;
	
	public class XMPPSocketConnectionExtension extends XMPPSocketConnection {
		protected var _mainServer:String;
		
		public function XMPPSocketConnectionExtension() {}
		
		/*THIS SERVER PROPERTY IS SETUP TO WORK ALONGSIDE THE CONNECTION SERVER*/
		public function get chatServer():String { return _mainServer; }
		public function set chatServer(newServer:String):void { _mainServer = newServer;	}
		
		/*THIS OVERRIDE IS TO SET THE 'TO' ATTRIBUTE TO A DIFFERENT SERVER TO THE CONNECT ONE*/
		override public function connect( streamType:String = "terminatedStandard" ):Boolean
		{
			active = false;
			loggedIn = false;
			
			// Stream type lets user set opening/closing tag - some servers (jadc2s) prefer <stream:flash> to the standard
			// <stream:stream>
			switch( streamType ) {
				case "flash":
					openingStreamTag = "<?xml version=\"1.0\"?><flash:stream to=\"" + chatServer + "\" xmlns=\"jabber:client\" xmlns:flash=\"http://www.jabber.com/streams/flash\" version=\"1.0\">";
					closingStreamTag = "</flash:stream>";
					break;
					
				case "terminatedFlash":
					openingStreamTag = "<?xml version=\"1.0\"?><flash:stream to=\"" + chatServer + "\" xmlns=\"jabber:client\" xmlns:flash=\"http://www.jabber.com/streams/flash\" version=\"1.0\" />";
					closingStreamTag = "</flash:stream>";
					break;
					
				case "standard":
					openingStreamTag = "<?xml version=\"1.0\"?><stream:stream to=\"" + chatServer + "\" xmlns=\"jabber:client\" xmlns:stream=\"http://etherx.jabber.org/streams\" version=\"1.0\">";
					closingStreamTag = "</stream:stream>";
					break;
			
				case "terminatedStandard":
				default:
					openingStreamTag = "<?xml version=\"1.0\"?><stream:stream to=\"" + chatServer + "\" xmlns=\"jabber:client\" xmlns:stream=\"http://etherx.jabber.org/streams\" version=\"1.0\" />";
					closingStreamTag = "</stream:stream>";
					break;
			}
			if(bTLSenabled){
					socketConn();
			}else{
			binarySocket.connect( server, port );
			}
			return true;
		}
		
		/*THIS OVERRIDE IS TO SET THE DOMAIN PART OF THE JID TO A DIFFERENT SERVER TO THE CONNECT ONE*/
		override public function get jid():JID
		{
			return new JID(myUsername + "@" + chatServer + "/" + myResource);
		}
		
		/*THIS OVERRIDE CHANGES AN APPARENT BUG IN XIFF WHERE IF SECURITY WAS ENABLED BUT NOT YET SETUP IT WOULD RUN THE REGISTER USER FUNCTION*/
		override protected function handleStream( node:XMLNode ):void
		{
			sessionID = node.attributes.id;
			
			if(_useAnonymousLogin) {
				sendAnonymousLogin();
			} else if( username != null && username.length > 0 && bUseTLS == false) {
				beginAuthentication();
			}else if(bUseTLS && bTLSenabled){
				beginAuthentication();
			} else {
				handleStreamFeatures(node);
			}
		}
		
		
		
	}
	
}